package sys

import (
	"lapp_-wy/db"
	"lapp_-wy/utils"
	"lapp_-wy/web/models"
	"time"

	"github.com/kataras/golog"
)

const (
	username = "admin"
	password = "123456"
)

// 检查超级用户是否存在
func CheckRootExit() bool {
	e := db.MasterEngine()
	// root is existed?
	exit, err := e.Exist(&models.Usertab{Userid: username})
	if err != nil {
		golog.Fatalf("@@@ When check Root User is exited? happened error. %s", err.Error())
	}
	if exit {
		golog.Info("@@@ Root User is existed.")

		// 初始化rbac_model
		r := models.Usertab{Userid: username}
		if exit, _ := e.Get(&r); exit {
			CreateSystemRole()
		}
	}
	return exit
}


func CreateRoot() {
	newRoot := models.Usertab{
		Pid:   100,
		Userid:   username,
		Password:   utils.Encrypt(password),
		Createtime: utils.TimeFormat(time.Now(),"yyyyMMddHHmmss"),
	}

	e := db.MasterEngine()
	if _, err := e.Insert(&newRoot); err != nil {
		golog.Fatalf("@@@ When create Root User happened error. %s", err.Error())
	}
}

